#include "stdafx.h"
#include "GRAFCETBonX.h"


//********************************************************************************
// 
//********************************************************************************
void GRAFCET_BON::AccionImpl::accept( BON::Visitor *pVisitor)
{
	// visit the Atom
	pVisitor->visitAtom( BON::Atom( this));

}


//********************************************************************************
// returns src GRAFCET_BON::Etapas
//********************************************************************************
std::multiset<GRAFCET_BON::Etapa> GRAFCET_BON::AccionImpl::getAsociacionSrcs()
{
	std::multiset<GRAFCET_BON::Etapa> res;
	{
		std::multiset<BON::ConnectionEnd> in_ends = BON::ConnectionEndImpl::getInConnEnds("Asociacion");
		for ( std::multiset<BON::ConnectionEnd>::iterator cit = in_ends.begin() ; cit != in_ends.end() ; ++cit )
		{
			GRAFCET_BON::Etapa dst( *cit );
			ASSERT(dst);
			res.insert( dst);
		}
	}
	return res;
}


//********************************************************************************
// 
//********************************************************************************
std::set<GRAFCET_BON::Asociacion> GRAFCET_BON::AccionImpl::getInAsociacionLinks()
{
	std::set<GRAFCET_BON::Asociacion> result;
	std::set<BON::Connection> conns = ConnectionEndImpl::getInConnLinks();
	std::set<BON::Connection>::iterator it = conns.begin();
	for( ; it != conns.end(); ++it)
	{
		GRAFCET_BON::Asociacion c( *it);
		if (c)
			result.insert( c);
	}
	return result;
}


//********************************************************************************
// 
//********************************************************************************
std::string GRAFCET_BON::AccionImpl::getExpresion() 
{
	return FCOImpl::getAttribute("Expresion")->getStringValue();
}


//********************************************************************************
// 
//********************************************************************************
void GRAFCET_BON::AccionImpl::setExpresion( const std::string& val)
{
	FCOImpl::getAttribute("Expresion")->setStringValue( val);
}


