#include "stdafx.h"
#include "GRAFCETBonX.h"


//********************************************************************************
// 
//********************************************************************************
void GRAFCET_BON::DiagramaGRAFCETImpl::accept( BON::Visitor *pVisitor)
{
	// visit the Model
	pVisitor->visitModel( BON::Model( this));

}


//********************************************************************************
// getter for role "Asociacion" among "GRAFCET_BON::Asociacion"s
//********************************************************************************
std::set<GRAFCET_BON::Asociacion> GRAFCET_BON::DiagramaGRAFCETImpl::getAsociacion()
{
	std::set<GRAFCET_BON::Asociacion> res;
	std::set<BON::FCO> roles = ModelImpl::getChildFCOsAs("Asociacion");
	for( std::set<BON::FCO>::iterator i = roles.begin(); i != roles.end(); ++i)
	{
		GRAFCET_BON::Asociacion elem(*i);
		ASSERT(elem);
		res.insert(elem);
	}
	return res;
}


//********************************************************************************
// getter for role "Etapa" among "Etapa"s and its descendants
//********************************************************************************
std::set<GRAFCET_BON::Etapa> GRAFCET_BON::DiagramaGRAFCETImpl::getEtapa()
{
	std::set<GRAFCET_BON::Etapa> res;
	std::set<BON::FCO> roles = ModelImpl::getChildFCOsAs("Etapa");
	for( std::set<BON::FCO>::iterator i = roles.begin(); i != roles.end(); ++i)
	{
		GRAFCET_BON::Etapa elem(*i);
		ASSERT(elem);
		res.insert(elem);
	}
	return res;
}


//********************************************************************************
// aggregated getter for role "GRAFCET_BON::" among "GRAFCET_BON::Etapa"s and its descendants
//********************************************************************************
std::set<GRAFCET_BON::Etapa> GRAFCET_BON::DiagramaGRAFCETImpl::getEtapa(int dummy)
{
	std::set<GRAFCET_BON::Etapa> res;
	const int len = 2;
	std::set<BON::FCO> roles_vec[ len];
	roles_vec[0] = ModelImpl::getChildFCOsAs("EtapaInicial");
	roles_vec[1] = ModelImpl::getChildFCOsAs("Etapa");
	for( int k = 0; k < len; ++k)
		for( std::set<BON::FCO>::iterator i = roles_vec[k].begin(); i != roles_vec[k].end(); ++i)
		{
			GRAFCET_BON::Etapa elem(*i);
			ASSERT(elem);
			res.insert(elem);
		}
	return res;
}


//********************************************************************************
// getter for role "EtapaInicial" among "Etapa"s and its descendants
//********************************************************************************
std::set<GRAFCET_BON::EtapaInicial> GRAFCET_BON::DiagramaGRAFCETImpl::getEtapaInicial()
{
	std::set<GRAFCET_BON::EtapaInicial> res;
	std::set<BON::FCO> roles = ModelImpl::getChildFCOsAs("EtapaInicial");
	for( std::set<BON::FCO>::iterator i = roles.begin(); i != roles.end(); ++i)
	{
		GRAFCET_BON::EtapaInicial elem(*i);
		ASSERT(elem);
		res.insert(elem);
	}
	return res;
}


//********************************************************************************
// getter for role "EtapaMultiple" among "GRAFCET_BON::EtapaMultiple"s
//********************************************************************************
std::set<GRAFCET_BON::EtapaMultiple> GRAFCET_BON::DiagramaGRAFCETImpl::getEtapaMultiple()
{
	std::set<GRAFCET_BON::EtapaMultiple> res;
	std::set<BON::FCO> roles = ModelImpl::getChildFCOsAs("EtapaMultiple");
	for( std::set<BON::FCO>::iterator i = roles.begin(); i != roles.end(); ++i)
	{
		GRAFCET_BON::EtapaMultiple elem(*i);
		ASSERT(elem);
		res.insert(elem);
	}
	return res;
}


//********************************************************************************
// getter for role "FinAND" among "GRAFCET_BON::FinAND"s
//********************************************************************************
std::set<GRAFCET_BON::FinAND> GRAFCET_BON::DiagramaGRAFCETImpl::getFinAND()
{
	std::set<GRAFCET_BON::FinAND> res;
	std::set<BON::FCO> roles = ModelImpl::getChildFCOsAs("FinAND");
	for( std::set<BON::FCO>::iterator i = roles.begin(); i != roles.end(); ++i)
	{
		GRAFCET_BON::FinAND elem(*i);
		ASSERT(elem);
		res.insert(elem);
	}
	return res;
}


//********************************************************************************
// getter for role "FinOR" among "GRAFCET_BON::FinOR"s
//********************************************************************************
std::set<GRAFCET_BON::FinOR> GRAFCET_BON::DiagramaGRAFCETImpl::getFinOR()
{
	std::set<GRAFCET_BON::FinOR> res;
	std::set<BON::FCO> roles = ModelImpl::getChildFCOsAs("FinOR");
	for( std::set<BON::FCO>::iterator i = roles.begin(); i != roles.end(); ++i)
	{
		GRAFCET_BON::FinOR elem(*i);
		ASSERT(elem);
		res.insert(elem);
	}
	return res;
}


//********************************************************************************
// getter for role "InicioAND" among "GRAFCET_BON::InicioAND"s
//********************************************************************************
std::set<GRAFCET_BON::InicioAND> GRAFCET_BON::DiagramaGRAFCETImpl::getInicioAND()
{
	std::set<GRAFCET_BON::InicioAND> res;
	std::set<BON::FCO> roles = ModelImpl::getChildFCOsAs("InicioAND");
	for( std::set<BON::FCO>::iterator i = roles.begin(); i != roles.end(); ++i)
	{
		GRAFCET_BON::InicioAND elem(*i);
		ASSERT(elem);
		res.insert(elem);
	}
	return res;
}


//********************************************************************************
// getter for role "InicioOR" among "GRAFCET_BON::InicioOR"s
//********************************************************************************
std::set<GRAFCET_BON::InicioOR> GRAFCET_BON::DiagramaGRAFCETImpl::getInicioOR()
{
	std::set<GRAFCET_BON::InicioOR> res;
	std::set<BON::FCO> roles = ModelImpl::getChildFCOsAs("InicioOR");
	for( std::set<BON::FCO>::iterator i = roles.begin(); i != roles.end(); ++i)
	{
		GRAFCET_BON::InicioOR elem(*i);
		ASSERT(elem);
		res.insert(elem);
	}
	return res;
}


//********************************************************************************
// getter for role "Instruccion" among "GRAFCET_BON::Instruccion"s
//********************************************************************************
std::set<GRAFCET_BON::Instruccion> GRAFCET_BON::DiagramaGRAFCETImpl::getInstruccion()
{
	std::set<GRAFCET_BON::Instruccion> res;
	std::set<BON::FCO> roles = ModelImpl::getChildFCOsAs("Instruccion");
	for( std::set<BON::FCO>::iterator i = roles.begin(); i != roles.end(); ++i)
	{
		GRAFCET_BON::Instruccion elem(*i);
		ASSERT(elem);
		res.insert(elem);
	}
	return res;
}


//********************************************************************************
// getter for role "Salida" among "GRAFCET_BON::Salida"s
//********************************************************************************
std::set<GRAFCET_BON::Salida> GRAFCET_BON::DiagramaGRAFCETImpl::getSalida()
{
	std::set<GRAFCET_BON::Salida> res;
	std::set<BON::FCO> roles = ModelImpl::getChildFCOsAs("Salida");
	for( std::set<BON::FCO>::iterator i = roles.begin(); i != roles.end(); ++i)
	{
		GRAFCET_BON::Salida elem(*i);
		ASSERT(elem);
		res.insert(elem);
	}
	return res;
}


//********************************************************************************
// getter for role "Salto" among "GRAFCET_BON::Salto"s
//********************************************************************************
std::set<GRAFCET_BON::Salto> GRAFCET_BON::DiagramaGRAFCETImpl::getSalto()
{
	std::set<GRAFCET_BON::Salto> res;
	std::set<BON::FCO> roles = ModelImpl::getChildFCOsAs("Salto");
	for( std::set<BON::FCO>::iterator i = roles.begin(); i != roles.end(); ++i)
	{
		GRAFCET_BON::Salto elem(*i);
		ASSERT(elem);
		res.insert(elem);
	}
	return res;
}


//********************************************************************************
// getter for role "SecuenciaInstrucciones" among "GRAFCET_BON::SecuenciaInstrucciones"s
//********************************************************************************
std::set<GRAFCET_BON::SecuenciaInstrucciones> GRAFCET_BON::DiagramaGRAFCETImpl::getSecuenciaInstrucciones()
{
	std::set<GRAFCET_BON::SecuenciaInstrucciones> res;
	std::set<BON::FCO> roles = ModelImpl::getChildFCOsAs("SecuenciaInstrucciones");
	for( std::set<BON::FCO>::iterator i = roles.begin(); i != roles.end(); ++i)
	{
		GRAFCET_BON::SecuenciaInstrucciones elem(*i);
		ASSERT(elem);
		res.insert(elem);
	}
	return res;
}


//********************************************************************************
// getter for role "Transicion" among "GRAFCET_BON::Transicion"s
//********************************************************************************
std::set<GRAFCET_BON::Transicion> GRAFCET_BON::DiagramaGRAFCETImpl::getTransicion()
{
	std::set<GRAFCET_BON::Transicion> res;
	std::set<BON::FCO> roles = ModelImpl::getChildFCOsAs("Transicion");
	for( std::set<BON::FCO>::iterator i = roles.begin(); i != roles.end(); ++i)
	{
		GRAFCET_BON::Transicion elem(*i);
		ASSERT(elem);
		res.insert(elem);
	}
	return res;
}


