#include "stdafx.h"
#include "GRAFCETBonX.h"


//********************************************************************************
// 
//********************************************************************************
void GRAFCET_BON::EtapaImpl::accept( BON::Visitor *pVisitor)
{
	// visit the Atom
	pVisitor->visitAtom( BON::Atom( this));

}


//********************************************************************************
// returns dst GRAFCET_BON::Accions
//********************************************************************************
std::multiset<GRAFCET_BON::Accion> GRAFCET_BON::EtapaImpl::getAsociacionDsts()
{
	std::multiset<GRAFCET_BON::Accion> res;
	{
		std::multiset<BON::ConnectionEnd> out_ends = BON::ConnectionEndImpl::getOutConnEnds("Asociacion");
		for ( std::multiset<BON::ConnectionEnd>::iterator cit = out_ends.begin() ; cit != out_ends.end() ; ++cit )
		{
			GRAFCET_BON::Accion dst( *cit );
			ASSERT(dst);
			res.insert( dst);
		}
	}
	return res;
}


//********************************************************************************
// returns dst GRAFCET_BON::InicioMultiples
//********************************************************************************
std::multiset<GRAFCET_BON::InicioMultiple> GRAFCET_BON::EtapaImpl::getInicioMultipleDsts()
{
	std::multiset<GRAFCET_BON::InicioMultiple> res;
	{
		std::multiset<BON::ConnectionEnd> out_ends = BON::ConnectionEndImpl::getOutConnEnds("EtapaMultiple");
		for ( std::multiset<BON::ConnectionEnd>::iterator cit = out_ends.begin() ; cit != out_ends.end() ; ++cit )
		{
			GRAFCET_BON::InicioMultiple dst( *cit );
			ASSERT(dst);
			res.insert( dst);
		}
	}
	return res;
}


//********************************************************************************
// returns dst GRAFCET_BON::FinMultiples
//********************************************************************************
std::multiset<GRAFCET_BON::FinMultiple> GRAFCET_BON::EtapaImpl::getFinMultipleDsts()
{
	std::multiset<GRAFCET_BON::FinMultiple> res;
	{
		std::multiset<BON::ConnectionEnd> out_ends = BON::ConnectionEndImpl::getOutConnEnds("EtapaMultiple");
		for ( std::multiset<BON::ConnectionEnd>::iterator cit = out_ends.begin() ; cit != out_ends.end() ; ++cit )
		{
			GRAFCET_BON::FinMultiple dst( *cit );
			ASSERT(dst);
			res.insert( dst);
		}
	}
	return res;
}


//********************************************************************************
// returns src GRAFCET_BON::FinMultiples
//********************************************************************************
std::multiset<GRAFCET_BON::FinMultiple> GRAFCET_BON::EtapaImpl::getFinMultipleSrcs()
{
	std::multiset<GRAFCET_BON::FinMultiple> res;
	{
		std::multiset<BON::ConnectionEnd> in_ends = BON::ConnectionEndImpl::getInConnEnds("EtapaMultiple");
		for ( std::multiset<BON::ConnectionEnd>::iterator cit = in_ends.begin() ; cit != in_ends.end() ; ++cit )
		{
			GRAFCET_BON::FinMultiple dst( *cit );
			ASSERT(dst);
			res.insert( dst);
		}
	}
	return res;
}


//********************************************************************************
// returns src GRAFCET_BON::InicioMultiples
//********************************************************************************
std::multiset<GRAFCET_BON::InicioMultiple> GRAFCET_BON::EtapaImpl::getInicioMultipleSrcs()
{
	std::multiset<GRAFCET_BON::InicioMultiple> res;
	{
		std::multiset<BON::ConnectionEnd> in_ends = BON::ConnectionEndImpl::getInConnEnds("EtapaMultiple");
		for ( std::multiset<BON::ConnectionEnd>::iterator cit = in_ends.begin() ; cit != in_ends.end() ; ++cit )
		{
			GRAFCET_BON::InicioMultiple dst( *cit );
			ASSERT(dst);
			res.insert( dst);
		}
	}
	return res;
}


//********************************************************************************
// 
//********************************************************************************
std::set<GRAFCET_BON::EtapaMultiple> GRAFCET_BON::EtapaImpl::getInEtapaMultipleLinks()
{
	std::set<GRAFCET_BON::EtapaMultiple> result;
	std::set<BON::Connection> conns = ConnectionEndImpl::getInConnLinks();
	std::set<BON::Connection>::iterator it = conns.begin();
	for( ; it != conns.end(); ++it)
	{
		GRAFCET_BON::EtapaMultiple c( *it);
		if (c)
			result.insert( c);
	}
	return result;
}

//********************************************************************************
// 
//********************************************************************************
std::set<GRAFCET_BON::Salto> GRAFCET_BON::EtapaImpl::getInSaltoLinks()
{
	std::set<GRAFCET_BON::Salto> result;
	std::set<BON::Connection> conns = ConnectionEndImpl::getInConnLinks();
	std::set<BON::Connection>::iterator it = conns.begin();
	for( ; it != conns.end(); ++it)
	{
		GRAFCET_BON::Salto c( *it);
		if (c)
			result.insert( c);
	}
	return result;
}


//********************************************************************************
// 
//********************************************************************************
std::set<GRAFCET_BON::Transicion> GRAFCET_BON::EtapaImpl::getInTransicionLinks()
{
	std::set<GRAFCET_BON::Transicion> result;
	std::set<BON::Connection> conns = ConnectionEndImpl::getInConnLinks();
	std::set<BON::Connection>::iterator it = conns.begin();
	for( ; it != conns.end(); ++it)
	{
		GRAFCET_BON::Transicion c( *it);
		if (c)
			result.insert( c);
	}
	return result;
}


//********************************************************************************
// 
//********************************************************************************
std::set<GRAFCET_BON::Asociacion> GRAFCET_BON::EtapaImpl::getOutAsociacionLinks()
{
	std::set<GRAFCET_BON::Asociacion> result;
	std::set<BON::Connection> conns = ConnectionEndImpl::getOutConnLinks();
	std::set<BON::Connection>::iterator it = conns.begin();
	for( ; it != conns.end(); ++it)
	{
		GRAFCET_BON::Asociacion c( *it);
		if (c)
			result.insert( c);
	}
	return result;
}


//********************************************************************************
// 
//********************************************************************************
std::set<GRAFCET_BON::EtapaMultiple> GRAFCET_BON::EtapaImpl::getOutEtapaMultipleLinks()
{
	std::set<GRAFCET_BON::EtapaMultiple> result;
	std::set<BON::Connection> conns = ConnectionEndImpl::getOutConnLinks();
	std::set<BON::Connection>::iterator it = conns.begin();
	for( ; it != conns.end(); ++it)
	{
		GRAFCET_BON::EtapaMultiple c( *it);
		if (c)
			result.insert( c);
	}
	return result;
}


//********************************************************************************
// 
//********************************************************************************
std::set<GRAFCET_BON::Salto> GRAFCET_BON::EtapaImpl::getOutSaltoLinks()
{
	std::set<GRAFCET_BON::Salto> result;
	std::set<BON::Connection> conns = ConnectionEndImpl::getOutConnLinks();
	std::set<BON::Connection>::iterator it = conns.begin();
	for( ; it != conns.end(); ++it)
	{
		GRAFCET_BON::Salto c( *it);
		if (c)
			result.insert( c);
	}
	return result;
}


//********************************************************************************
// 
//********************************************************************************
std::set<GRAFCET_BON::Transicion> GRAFCET_BON::EtapaImpl::getOutTransicionLinks()
{
	std::set<GRAFCET_BON::Transicion> result;
	std::set<BON::Connection> conns = ConnectionEndImpl::getOutConnLinks();
	std::set<BON::Connection>::iterator it = conns.begin();
	for( ; it != conns.end(); ++it)
	{
		GRAFCET_BON::Transicion c( *it);
		if (c)
			result.insert( c);
	}
	return result;
}


//********************************************************************************
// returns dst GRAFCET_BON::Etapas
//********************************************************************************
std::multiset<GRAFCET_BON::Etapa> GRAFCET_BON::EtapaImpl::getSaltoDsts()
{
	std::multiset<GRAFCET_BON::Etapa> res;
	{
		std::multiset<BON::ConnectionEnd> out_ends = BON::ConnectionEndImpl::getOutConnEnds("Salto");
		for ( std::multiset<BON::ConnectionEnd>::iterator cit = out_ends.begin() ; cit != out_ends.end() ; ++cit )
		{
			GRAFCET_BON::Etapa dst( *cit );
			ASSERT(dst);
			res.insert( dst);
		}
	}
	return res;
}


//********************************************************************************
// 
//********************************************************************************
std::set<GRAFCET_BON::Salto> GRAFCET_BON::EtapaImpl::getSaltoLinks()
{
	std::set<GRAFCET_BON::Salto> result;
	std::set<BON::Connection> conns = ConnectionEndImpl::getConnLinks();
	std::set<BON::Connection>::iterator it = conns.begin();
	for( ; it != conns.end(); ++it)
	{
		GRAFCET_BON::Salto c( *it);
		if (c)
			result.insert( c);
	}
	return result;
}


//********************************************************************************
// returns src GRAFCET_BON::Etapas
//********************************************************************************
std::multiset<GRAFCET_BON::Etapa> GRAFCET_BON::EtapaImpl::getSaltoSrcs()
{
	std::multiset<GRAFCET_BON::Etapa> res;
	{
		std::multiset<BON::ConnectionEnd> in_ends = BON::ConnectionEndImpl::getInConnEnds("Salto");
		for ( std::multiset<BON::ConnectionEnd>::iterator cit = in_ends.begin() ; cit != in_ends.end() ; ++cit )
		{
			GRAFCET_BON::Etapa dst( *cit );
			ASSERT(dst);
			res.insert( dst);
		}
	}
	return res;
}


//********************************************************************************
// returns dst GRAFCET_BON::Etapas
//********************************************************************************
std::multiset<GRAFCET_BON::Etapa> GRAFCET_BON::EtapaImpl::getTransicionDsts()
{
	std::multiset<GRAFCET_BON::Etapa> res;
	{
		std::multiset<BON::ConnectionEnd> out_ends = BON::ConnectionEndImpl::getOutConnEnds("Transicion");
		for ( std::multiset<BON::ConnectionEnd>::iterator cit = out_ends.begin() ; cit != out_ends.end() ; ++cit )
		{
			GRAFCET_BON::Etapa dst( *cit );
			ASSERT(dst);
			res.insert( dst);
		}
	}
	return res;
}


//********************************************************************************
// 
//********************************************************************************
std::set<GRAFCET_BON::Transicion> GRAFCET_BON::EtapaImpl::getTransicionLinks()
{
	std::set<GRAFCET_BON::Transicion> result;
	std::set<BON::Connection> conns = ConnectionEndImpl::getConnLinks();
	std::set<BON::Connection>::iterator it = conns.begin();
	for( ; it != conns.end(); ++it)
	{
		GRAFCET_BON::Transicion c( *it);
		if (c)
			result.insert( c);
	}
	return result;
}


//********************************************************************************
// returns src GRAFCET_BON::Etapas
//********************************************************************************
std::multiset<GRAFCET_BON::Etapa> GRAFCET_BON::EtapaImpl::getTransicionSrcs()
{
	std::multiset<GRAFCET_BON::Etapa> res;
	{
		std::multiset<BON::ConnectionEnd> in_ends = BON::ConnectionEndImpl::getInConnEnds("Transicion");
		for ( std::multiset<BON::ConnectionEnd>::iterator cit = in_ends.begin() ; cit != in_ends.end() ; ++cit )
		{
			GRAFCET_BON::Etapa dst( *cit );
			ASSERT(dst);
			res.insert( dst);
		}
	}
	return res;
}


