#include "stdafx.h"
#include "GRAFCETBonX.h"


//********************************************************************************
// 
//********************************************************************************
void GRAFCET_BON::FinMultipleImpl::accept( BON::Visitor *pVisitor)
{
	// visit the Atom
	pVisitor->visitAtom( BON::Atom( this));

}


//********************************************************************************
// returns dst GRAFCET_BON::Etapas
//********************************************************************************
std::multiset<GRAFCET_BON::Etapa> GRAFCET_BON::FinMultipleImpl::getEtapaMultipleDsts()
{
	std::multiset<GRAFCET_BON::Etapa> res;
	{
		std::multiset<BON::ConnectionEnd> out_ends = BON::ConnectionEndImpl::getOutConnEnds("EtapaMultiple");
		for ( std::multiset<BON::ConnectionEnd>::iterator cit = out_ends.begin() ; cit != out_ends.end() ; ++cit )
		{
			GRAFCET_BON::Etapa dst( *cit );
			ASSERT(dst);
			res.insert( dst);
		}
	}
	return res;
}


//********************************************************************************
// returns src GRAFCET_BON::Etapas
//********************************************************************************
std::multiset<GRAFCET_BON::Etapa> GRAFCET_BON::FinMultipleImpl::getEtapaMultipleSrcs()
{
	std::multiset<GRAFCET_BON::Etapa> res;
	{
		std::multiset<BON::ConnectionEnd> in_ends = BON::ConnectionEndImpl::getInConnEnds("EtapaMultiple");
		for ( std::multiset<BON::ConnectionEnd>::iterator cit = in_ends.begin() ; cit != in_ends.end() ; ++cit )
		{
			GRAFCET_BON::Etapa dst( *cit );
			ASSERT(dst);
			res.insert( dst);
		}
	}
	return res;
}


//********************************************************************************
// 
//********************************************************************************
std::set<GRAFCET_BON::EtapaMultiple> GRAFCET_BON::FinMultipleImpl::getInEtapaMultipleLinks()
{
	std::set<GRAFCET_BON::EtapaMultiple> result;
	std::set<BON::Connection> conns = ConnectionEndImpl::getInConnLinks();
	std::set<BON::Connection>::iterator it = conns.begin();
	for( ; it != conns.end(); ++it)
	{
		GRAFCET_BON::EtapaMultiple c( *it);
		if (c)
			result.insert( c);
	}
	return result;
}


//********************************************************************************
// 
//********************************************************************************
std::set<GRAFCET_BON::EtapaMultiple> GRAFCET_BON::FinMultipleImpl::getOutEtapaMultipleLinks()
{
	std::set<GRAFCET_BON::EtapaMultiple> result;
	std::set<BON::Connection> conns = ConnectionEndImpl::getOutConnLinks();
	std::set<BON::Connection>::iterator it = conns.begin();
	for( ; it != conns.end(); ++it)
	{
		GRAFCET_BON::EtapaMultiple c( *it);
		if (c)
			result.insert( c);
	}
	return result;
}


