#include "stdafx.h"
#include "GRAFCETBonX.h"


//********************************************************************************
// 
//********************************************************************************
void GRAFCET_BON::InstruccionImpl::accept( BON::Visitor *pVisitor)
{
	// visit the Atom
	pVisitor->visitAtom( BON::Atom( this));

}


//********************************************************************************
// 
//********************************************************************************
std::set<GRAFCET_BON::SecuenciaInstrucciones> GRAFCET_BON::InstruccionImpl::getInSecuenciaInstruccionesLinks()
{
	std::set<GRAFCET_BON::SecuenciaInstrucciones> result;
	std::set<BON::Connection> conns = ConnectionEndImpl::getInConnLinks();
	std::set<BON::Connection>::iterator it = conns.begin();
	for( ; it != conns.end(); ++it)
	{
		GRAFCET_BON::SecuenciaInstrucciones c( *it);
		if (c)
			result.insert( c);
	}
	return result;
}


//********************************************************************************
// 
//********************************************************************************
std::set<GRAFCET_BON::SecuenciaInstrucciones> GRAFCET_BON::InstruccionImpl::getOutSecuenciaInstruccionesLinks()
{
	std::set<GRAFCET_BON::SecuenciaInstrucciones> result;
	std::set<BON::Connection> conns = ConnectionEndImpl::getOutConnLinks();
	std::set<BON::Connection>::iterator it = conns.begin();
	for( ; it != conns.end(); ++it)
	{
		GRAFCET_BON::SecuenciaInstrucciones c( *it);
		if (c)
			result.insert( c);
	}
	return result;
}


//********************************************************************************
// returns dst GRAFCET_BON::Instruccions
//********************************************************************************
std::multiset<GRAFCET_BON::Instruccion> GRAFCET_BON::InstruccionImpl::getSecuenciaInstruccionesDsts()
{
	std::multiset<GRAFCET_BON::Instruccion> res;
	{
		std::multiset<BON::ConnectionEnd> out_ends = BON::ConnectionEndImpl::getOutConnEnds("SecuenciaInstrucciones");
		for ( std::multiset<BON::ConnectionEnd>::iterator cit = out_ends.begin() ; cit != out_ends.end() ; ++cit )
		{
			GRAFCET_BON::Instruccion dst( *cit );
			ASSERT(dst);
			res.insert( dst);
		}
	}
	return res;
}


//********************************************************************************
// 
//********************************************************************************
std::set<GRAFCET_BON::SecuenciaInstrucciones> GRAFCET_BON::InstruccionImpl::getSecuenciaInstruccionesLinks()
{
	std::set<GRAFCET_BON::SecuenciaInstrucciones> result;
	std::set<BON::Connection> conns = ConnectionEndImpl::getConnLinks();
	std::set<BON::Connection>::iterator it = conns.begin();
	for( ; it != conns.end(); ++it)
	{
		GRAFCET_BON::SecuenciaInstrucciones c( *it);
		if (c)
			result.insert( c);
	}
	return result;
}


//********************************************************************************
// returns src GRAFCET_BON::Instruccions
//********************************************************************************
std::multiset<GRAFCET_BON::Instruccion> GRAFCET_BON::InstruccionImpl::getSecuenciaInstruccionesSrcs()
{
	std::multiset<GRAFCET_BON::Instruccion> res;
	{
		std::multiset<BON::ConnectionEnd> in_ends = BON::ConnectionEndImpl::getInConnEnds("SecuenciaInstrucciones");
		for ( std::multiset<BON::ConnectionEnd>::iterator cit = in_ends.begin() ; cit != in_ends.end() ; ++cit )
		{
			GRAFCET_BON::Instruccion dst( *cit );
			ASSERT(dst);
			res.insert( dst);
		}
	}
	return res;
}


